# -*- Mode: Perl -*-
# t/02_base.t -- test basic functionality

$TEST_DIR = './t';
#use lib qw(../blib/lib); $TEST_DIR = '.'; # for debugging

# load what we'll need
use Data::FStructure;
do "$TEST_DIR/common.plt";

plan(test => 9);

# 1
isok('new',($fs = Data::FStructure->new));
# 2
isok('root',$fs->root('q0') && $fs->root eq 'q0');
# 3
isok('nvalue [get/set]', $fs->nvalue([],'q17') && $fs->root eq 'q17');
# 4
isok('pvalue [get/set]', $fs->pvalue([],'foo') && $fs->pvalue([])->type eq 'foo');
# 5
ulistok('unreachable [non-empty]', [$fs->unreachable_nodes],['q0']);
# 6
isok('substructure re-link', $fs->pvalue(['f1'],$fs->substructure('q0')));
# 7
isok('unreachable [empty]', !$fs->unreachable_nodes);
# 8
isok('rename_nodes', $fs->rename_nodes(q17=>'george',q0=>'seymour'));
# 9
isok('has_nodes',$fs->has_nodes(qw(george seymour)) && !$fs->has_nodes(qw(q0 q17)));


print "\n";
# end of t/02_base.t
